function [rev variance pmargin nu1] = supplyObjectiveMex(gamma)
  global ban pop weights profitData demographics index data dates markets mySeed saveNu arg
  rev = zeros(88,1);
  variance = zeros(88,1);
  pmargin = zeros(88,1);
  saveNu=cell(21,88);
  nu1=[];
  for m=1:88
    fprintf('Market: %d\n',m);
%    if(find(ban==m))
%      fprintf('Banned\n');
%    end
    m_nu = [];

    profitData.market = m-1;
    profitData.gamma = [1 (pop(m)<500)*gamma(89)+((pop(m)>=500)*(pop(m)<1500))*gamma(90)+(pop(m)>=1500)*gamma(91)];
    profitData.omega = weights{m};
    for d=1:dates
      if(d<4)
        profitData.dummy=1;
      else
        profitData.dummy=profitData.arg(profitData.parameters+profitData.demoCharacteristics*profitData.product+profitData.random_effects+profitData.extra_parameters+floor((d-2)/2));
      end
      idx=(d-1)*88+profitData.market;
      dataIdx = [index(idx+1)+1:index(idx+2)];
      stations = index(idx+2)-index(idx+1);

      dataLocal=data(dataIdx,:);
      owner_share = [];
      for i=1:stations
        I=find(dataLocal(:,3)==dataLocal(i,3));
        owner_share=[owner_share; sum(dataLocal(I,4))];
      end
      xi=zeros(size(dataLocal,1),1);
      xi_number=dataLocal(:,19)+1;
      nondark_idx=find(xi_number~=0); %% 0 was -1, means entry
      xi(nondark_idx)=arg(xi_number(nondark_idx)+profitData.allParams);

      % 1-fm, 2-format, 3-owner, 4-owner_share, 5-station_share, 6-xi, 7-q
      M=[dataLocal(:,1) dataLocal(:,2) dataLocal(:,3) owner_share dataLocal(:,4) xi dataLocal(:,5) dataLocal(:,6)];
      Z=[ones(stations,1) dataLocal(:,8) dataLocal(:,9) dataLocal(:,10)];
      [M I]=sortrows(M,[-4 3]);
      Z=Z(I,:);

      % initial demographics
      profitData.demographics=demographics(:,idx*profitData.N+1:(idx+1)*profitData.N);

      M(:,3) = createRanking(M(:,3));
      ranking = createRanking(M(:,3));
      M=[M ranking'];
    
      I=find(M(:,2)~=8);
    
      profitData.q=M(I,7);
      profitData.data=M(I,:)';
      profitData.stations=size(I,1);

      profitData.reInit=1;
      epsilonFullMex(profitData, mySeed);

      profitData.reInit=0;
      nu = epsilonFullMex(profitData, mySeed);

      % compute revenue
      profitData.solve=0;
      profitData.epsilon=nu;
%      profitData.epsilon=zeros(size(nu));
      
      temp=-gamma(m)*ones(index(idx+2)-index(idx+1),1);
      temp(I)=nu;
      saveNu{d,m}=temp;
      [pii owner_shares station_shares mySeed_test pii_station q]=profitIpoptMex(profitData,mySeed);
      pii_station

      pmargin(m)=pmargin(m)+(sum(pii_station)+sum(nu.*profitData.q))/sum(pii_station);
      % [pii_station nu.*profitData.q (pii_station+nu.*profitData.q)./pii_station]
      rev(m)=rev(m)+mean(pii_station);

      m_nu = [m_nu;nu+gamma(m)];
    end
    variance(m)=sqrt(var(m_nu));
    nu1=[nu1; m_nu/variance(m)];
  end
  rev=rev/dates;
  pmargin=pmargin/dates;
end
