/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.c
 * Copyright (C) Unknown 2008 <przemekj@stanford.edu>
 * 
 * main.cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _NEWT_H__
#define _NEWT_H__

#define NEWTON__STEP 0.5
#define ALF 1e-5
#define TOLX 1e-10
#define MAXITS 50000
#define TOLF 1e-8
#define TOLMIN 1e-10
#define STPMX 100.0
#define FMAX(a,b) (((a) > (b)) ? (a) : (b))

double *fvec;

void lnsrch(int n, double *xold, float fold, double *g, double *p,  
   double *x, double *f, double stpmax, int *check);

int newt(double *x, int n);

double fmin2(double *x,int n);

#endif
