#include<tripletToCompressed.h>
#include<stdlib.h>

void tripletToCompressed(int size, int n, int m, int *Rows, int *Columns, 
    double *Rows_triplet, double *Columns_triplet, double *Transpose) {
  int i,j;
  int cumSum;
  int *ColumnNumber;

  ColumnNumber = (int *) malloc(m*sizeof(int));
  for(j=0;j<m;++j) {
    Columns_triplet[j]=0;
    ColumnNumber[j]=0;
  }
  Columns_triplet[m]=0;

  for(i=0;i<size;++i) {
    Columns_triplet[Columns[i]+1]++;
  }
  for(j=1;j<=m;++j) {
    Columns_triplet[j]+=Columns_triplet[j-1];
  }


  for(i=0;i<size;i++) {
    cumSum = Columns_triplet[Columns[i]]+ColumnNumber[Columns[i]];
    Transpose[i]=cumSum;
    Rows_triplet[(int) Transpose[i]]=Rows[i];
    ColumnNumber[Columns[i]]++;
  }

  free(ColumnNumber);
}
/*
int main() {
  int c[] = {1, 3, 0, 1, 5, 3};
  int r[] = {0, 1, 2, 2, 3, 5};
  int i;
  int ro[6], co[6], to[6];

  tripletToCompressed(6, 6, 6, r, c, ro, co, to);

  for(i=0;i<7;++i) {
    printf("%d ", ro[i]);
  }
  printf("\n");
  for(i=0;i<6;++i) {
    printf("%d ", co[i]);
  }
  printf("\n");
  for(i=0;i<6;++i) {
    printf("%d ", to[i]);
  }
  printf("\n");
}
*/
